%% Experiments
% 4.1) Sensitivities

Configuration = 1;

f = figure('Position',[200,150,900,600]);
N = 3;
fx = 300;
cx = 320;
cy = 240;
K = [fx 0 cx;0 fx cy;0 0 1];
P = diag([3,8,6])*(rand(3,N)-.5)*0;

ax = axes;
C = linspace(0,1,N);
plt_P = plot3(P(1,:),P(2,:),P(3,:),'r.');
view([-40,20])
colormap hsv
axis equal vis3d
hold on
grid on
xlim([-14 4])
ylim([-14 14])
zlim([-8 8])
ax.Position = [.0 .15 .7 .7];

Nc = 2;
Pc = zeros(3,Nc);
tc = zeros(3,Nc);
Rc = cell(Nc,1);
for i = 1:Nc
    Pc(:,i) = [-8.0;0;0]+1.0*diag([4,20,7])*(rand(3,1)-.5);
    switch(Configuration)
        case 1
            Pc(:,1) = [-5;1;0];
            Pc(:,2) = [-5;-1;0];
        case 2
            Pc(:,1) = [-12;0;0];
            Pc(:,2) = [-2;0;0];
        case 3
            Pc(:,1) = [-10;2;1];
            Pc(:,2) = [-5;-2;-1];
    end
    zi = -Pc(:,i)/norm(Pc(:,i));
    xi = cross(zi,[0;0;1]);
    xi = xi/norm(xi);
    yi = cross(zi,xi);
    Rc{i} = [xi yi zi]';%*angle2dcm(randn*.15,randn*0.05,randn*.10);
    Rc{i} = [0 -1 0;0 0 -1;1 0 0];
    plotCamera('Location',Pc(:,i),'Orientation',Rc{i},'Size',.5,'Label',['c' num2str(i)]);
    tc(:,i) = -Rc{i}*Pc(:,i);
end
set(gcf,'Renderer','opengl');
view([-54,25])

plt_c = patch([],[],[]);
for i = 1:Nc
    axi = axes;
    axi.Position = [.72 .04+(i-1)*.98/Nc .25 .7/Nc];
    axi.Box = 'On';
    title(['Camera' num2str(i)])
    p_i = [Rc{i} tc(:,i)]*[P;ones(1,N)];
    qi = K*p_i./p_i(3,:);
    qi = qi(1:2,:);
    plt_c(i) = plot(qi(1,:),qi(2,:),'r.');
    set(gca,'Ydir','reverse')
    grid on
    axis equal
    xlim([0,640])
    ylim([0,480])
end

drawnow

cameraParams = cameraParameters('IntrinsicMatrix',[fx 0 0;0 fx 0;cx cy 1]);

Pm = mean(Pc,2);
Scal = mean(sqrt(sum((Pc - repmat(Pm,1,Nc)).^2)));
I3 = eye(3);

%% =========================================
sn = 1e-10;
k = 0;
me_Mid = zeros(1,1);
me_WMid = zeros(1,1);
me_L2 = zeros(1,1);
me_L1 = zeros(1,1);
me_AngL2 = zeros(1,1);
me_AngL1 = zeros(1,1);
md1 = zeros(1);
md2 = zeros(1);
md3 = zeros(1);
md4 = zeros(1);
md5 = zeros(1);
md6 = zeros(1);
ma1 = zeros(1);
ma2 = zeros(1);
ma3 = zeros(1);
ma4 = zeros(1);
ma5 = zeros(1);
ma6 = zeros(1);
mt1 = zeros(1);
mt2 = zeros(1);
mt3 = zeros(1);
mt4 = zeros(1);
mt5 = zeros(1);
mt6 = zeros(1);
se1 = zeros(1,1);
f.CurrentAxes = ax;
for nl = 1:10 % noise levels
    k = 0;
    for i = 1:100 % iterations
        disp(i)
        P = randn(3,N);
        r = diag(rand(1,N)*.5)/2;
        P = P./sqrt(sum(P.^2,1))*r;
        plot3(P(1,:),P(2,:),P(3,:),'m.')
        
        qn = cell(Nc,1);
        for j = 1:Nc
            p = [Rc{j} tc(:,j)]*[P;ones(1,N)];
            q = K*p./p(3,:);
            q = q(1:2,:);
            qn{j} = q+randn(2,N)*sn;
        end
                
        k = k + 1;
        Pr1 = zeros(3,N);
        Pr2 = zeros(3,N);
        Pr3 = zeros(3,N);
        Pr4 = zeros(3,N);
        Pr5 = zeros(3,N);
        Pr6 = zeros(3,N);
        Ps = Pc+randn(3,Nc)*.01*nl;
        Rhc = Rc;
        for j = 1:length(Rhc)
            r = randn(1,3);
            r = r/norm(r);
            kappa = 2000;
            th = randn*.1*nl*pi/180;
            Rn = axang2rotm([r th]);
            Rhc{j} = Rhc{j}*Rn;
        end
        options = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
            'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',true,'MaxIterations',1000,'FunctionTolerance',1e-10,'StepTolerance',1e-10);
        options_wog = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
            'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',false,'MaxIterations',1000,'FunctionTolerance',1e-10,'StepTolerance',1e-10);
        for j = 1:N
            X = zeros(3,Nc);
            for l = 1:Nc
                X(:,l) = Rhc{l}\(K\[qn{l}(:,j);1]);
            end
            p = BestPoint(Ps,X);
            Pr1(:,j) = p;
            p = BestPointWeighted(Ps,X);
            Pr2(:,j) = p;
            
            P0 = Pr1(:,j)+0*randn(3,1);
            qns = zeros(2,Nc);
            for l = 1:Nc
                qns(:,l) = qn{l}(:,j);
            end
            if Nc == 2
                p = Hartly(Ps,Rhc,qns,K);
            else
                p = lsqnonlin(@(P) triCost(P,Ps,Rhc,qns,K),P0,[],[],options);
            end
            Pr3(:,j) = p;
            p = lsqnonlin(@(P) triCostL1(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
            Pr4(:,j) = p;
            p = lsqnonlin(@(P) triCostAngL2(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
            Pr5(:,j) = p;
            p = lsqnonlin(@(P) triCostAngL1(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
            Pr6(:,j) = p;
        end
        plot3(Pr1(1,:),Pr1(2,:),Pr1(3,:),'r.','Markersize',8)
        me_Mid(k) = mean(sqrt(sum((Pr1 - P).^2)));
        me_WMid(k) = mean(sqrt(sum((Pr2 - P).^2)));
        me_L2(k) = mean(sqrt(sum((Pr3 - P).^2)));
        me_L1(k) = mean(sqrt(sum((Pr4 - P).^2)));
        me_AngL2(k) = mean(sqrt(sum((Pr5 - P).^2)));
        me_AngL1(k) = mean(sqrt(sum((Pr6 - P).^2)));
        se1(k,nl) = std(sqrt(sum((Pr1 - P).^2)));
        mt1(k,nl) = norm(Pr1(:,1)-P(:,1));
        mt2(k,nl) = norm(Pr2(:,1)-P(:,1));
        mt3(k,nl) = norm(Pr3(:,1)-P(:,1));
        mt4(k,nl) = norm(Pr4(:,1)-P(:,1));
        mt5(k,nl) = norm(Pr5(:,1)-P(:,1));
        mt6(k,nl) = norm(Pr6(:,1)-P(:,1));
        d = P(:,2)-P(:,1);
        d1 = Pr1(:,2)-Pr1(:,1);
        d2 = Pr2(:,2)-Pr2(:,1);
        d3 = Pr3(:,2)-Pr3(:,1);
        d4 = Pr4(:,2)-Pr4(:,1);
        d5 = Pr5(:,2)-Pr5(:,1);
        d6 = Pr6(:,2)-Pr6(:,1);
        md1(k,nl) = abs(norm(d1)-norm(d));
        md2(k,nl) = abs(norm(d2)-norm(d));
        md3(k,nl) = abs(norm(d3)-norm(d));
        md4(k,nl) = abs(norm(d4)-norm(d));
        md5(k,nl) = abs(norm(d5)-norm(d));
        md6(k,nl) = abs(norm(d6)-norm(d));
        d_ = P(:,3)-P(:,2);
        d1_ = Pr1(:,3)-Pr1(:,2);
        d2_ = Pr2(:,3)-Pr2(:,2);
        d3_ = Pr3(:,3)-Pr3(:,2);
        d4_ = Pr4(:,3)-Pr4(:,2);
        d5_ = Pr5(:,3)-Pr5(:,2);
        d6_ = Pr6(:,3)-Pr6(:,2);
        alpha = asind(norm(cross(d,d_))/norm(d)/norm(d_));
        ma1(k,nl) = abs(asind(norm(cross(d1,d1_))/norm(d1)/norm(d1_))-alpha);
        ma2(k,nl) = abs(asind(norm(cross(d2,d2_))/norm(d2)/norm(d2_))-alpha);
        ma3(k,nl) = abs(asind(norm(cross(d3,d3_))/norm(d3)/norm(d3_))-alpha);
        ma4(k,nl) = abs(asind(norm(cross(d4,d4_))/norm(d4)/norm(d4_))-alpha);
        ma5(k,nl) = abs(asind(norm(cross(d5,d5_))/norm(d5)/norm(d5_))-alpha);
        ma6(k,nl) = abs(asind(norm(cross(d6,d6_))/norm(d6)/norm(d6_))-alpha);
    end
end
%%
figure
decim = mean(mt1);
semilogy(mean(mt1)./decim,'o-')
hold on
semilogy(mean(mt2)./decim,'*-')
semilogy(mean(mt3)./decim,'s-')
semilogy(mean(mt4)./decim,'h-')
semilogy(mean(mt5)./decim,'x-')
semilogy(mean(mt6)./decim,'^-')
legend({'MP','IRMP','L2','L1','AngL2','AngL1'})
title('mean(mt)')
grid on

figure
decim = median(mt1);
semilogy(median(mt1)./decim,'o--')
hold on
semilogy(median(mt2)./decim,'*--')
semilogy(median(mt3)./decim,'s--')
semilogy(median(mt4)./decim,'h--')
semilogy(median(mt5)./decim,'x--')
semilogy(median(mt6)./decim,'^--')
legend({'MP','IRMP','L2','L1','AngL2','AngL1'})
title('median(mt)')
grid on

figure
decim = mean(md1);
semilogy(mean(md1)./decim,'o-')
hold on
semilogy(mean(md2)./decim,'*-')
semilogy(mean(md3)./decim,'s-')
semilogy(mean(md4)./decim,'h-')
semilogy(mean(md5)./decim,'x-')
semilogy(mean(md6)./decim,'^-')
legend({'MP','IRMP','L2','L1','AngL2','AngL1'})
title('mean(md)')
grid on

figure
decim = median(md1);
semilogy(median(md1)./decim,'o--')
hold on
semilogy(median(md2)./decim,'*--')
semilogy(median(md3)./decim,'s--')
semilogy(median(md4)./decim,'h--')
semilogy(median(md5)./decim,'x--')
semilogy(median(md6)./decim,'^--')
legend({'MP','IRMP','L2','L1','AngL2','AngL1'})
title('median(md)')
grid on

figure
decim = mean(ma1);
semilogy(mean(ma1)./decim,'o-')
hold on
semilogy(mean(ma2)./decim,'*-')
semilogy(mean(ma3)./decim,'s-')
semilogy(mean(ma4)./decim,'h-')
semilogy(mean(ma5)./decim,'x-')
semilogy(mean(ma6)./decim,'^-')
legend({'MP','IRMP','L2','L1','AngL2','AngL1'})
title('mean(ma)')
grid on

figure
decim = median(ma1);
semilogy(median(ma1)./decim,'o--')
hold on
semilogy(median(ma2)./decim,'*--')
semilogy(median(ma3)./decim,'s--')
semilogy(median(ma4)./decim,'h--')
semilogy(median(ma5)./decim,'x--')
semilogy(median(ma6)./decim,'^--')
legend({'MP','IRMP','L2','L1','AngL2','AngL1'})
title('median(ma)')
grid on
