%% Experiments
% 4.2) Full Reconstruction Procedure on Synthetic Datasets

clear
N = 20;
Nc = 3;
Nitr = 10;
fx = 300;
cx = 320;
cy = 240;
K = [fx 0 cx;0 fx cy;0 0 1];

P = diag([3,8,6])*(rand(3,N)-.5);
P(:,1)=[3,8,6]/2;
P(:,2)=[3,-8,6]/2;
P(:,3)=[3,-8,-6]/2;
P(:,4)=[3,8,-6]/2;
P(:,5)=[3,8,6]/2;
P(:,6)=[-3,8,6]/2;
P(:,7)=[-3,-8,6]/2;
P(:,8)=[-3,-8,-6]/2;
P(:,9)=[-3,8,-6]/2;
P(:,10)=[-3,8,6]/2;
P(:,11)=[-3,-8,6]/2;
P(:,12)=[3,-8,6]/2;
P(:,13)=[3,-8,-6]/2;
P(:,14)=[-3,-8,-6]/2;
P(:,15)=[-3,8,-6]/2;
P(:,16)=[3,8,-6]/2;
P(1,17:N) = 3/2;
P(2,17:N) = 8/2;
P(3,17:N) = -6/2;

f = figure('Position',[200,150,900,600]);
ax = axes;
C = linspace(0,1,N);
plt_P = patch(P(1,:),P(2,:),P(3,:),C,'FaceColor','none','EdgeColor','flat','Marker','.','MarkerFaceColor','flat','Markersize',18);
view([-40,20])
colormap hsv
axis equal vis3d
hold on
grid on
xlim([-14 4])
ylim([-14 14])
zlim([-8 8])
ax.Position = [.0 .15 .7 .7];

Pc = zeros(3,Nc);
tc = zeros(3,Nc);
Rc = cell(Nc,1);
for i = 1:Nc
    Pc(:,1) = [-7;3;0];
    Pc(:,2) = [-10;-3;1];
    if Nc == 3
        Pc(:,3) = [-8;0;-2];
    end
    zi = -Pc(:,i)/norm(Pc(:,i));
    xi = cross(zi,[0;0;1]);
    xi = xi/norm(xi);
    yi = cross(zi,xi);
    Rc{i} = [xi yi zi]';
    plotCamera('Location',Pc(:,i),'Orientation',Rc{i},'Size',.5,'Label',['c' num2str(i)]);
    tc(:,i) = -Rc{i}*Pc(:,i);
end
set(gcf,'Renderer','opengl');
view([-54,25])

idx = combnk(1:Nc,2)-1;

plt_c = patch([],[],[]);
for i = 1:Nc
    axi = axes;
    axi.Position = [.72 .04+(i-1)*.98/Nc .25 .7/Nc];
    axi.Box = 'On';
    title(['Camera' num2str(i)])
    p_i = [Rc{i} tc(:,i)]*[P;ones(1,N)];
    qi = K*p_i./p_i(3,:);
    qi = qi(1:2,:);
    plt_c(i) = patch(qi(1,:),qi(2,:),C,'FaceColor','none','EdgeColor','flat','Marker','.','MarkerFaceColor','flat','Markersize',15);
    set(gca,'Ydir','reverse')
    grid on
    axis equal
    xlim([0,640])
    ylim([0,480])
end

button = questdlg('Continue?','','Yes','No','Yes');
if ~strcmp(button,'Yes')
    return
end

cameraParams = cameraParameters('IntrinsicMatrix',[fx 0 0;0 fx 0;cx cy 1]);

%% =========================================
sn = 1;
k = 0;
mep1 = zeros(1,Nc);
me_Mid = zeros(1,1);
me_WMid = zeros(1,1);
me_L2 = zeros(1,1);
me_L1 = zeros(1,1);
me_AngL2 = zeros(1,1);
me_AngL1 = zeros(1,1);
me_QSweep = zeros(1,1);
se1 = zeros(1,1);
se2 = zeros(1,1);
se3 = zeros(1,1);
se4 = zeros(1,1);
se5 = zeros(1,1);
se6 = zeros(1,1);
se7 = zeros(1,1);
htc = zeros(500,3);
hid = zeros(500,1);
f.CurrentAxes = ax;
for i = 1:Nitr
    disp(i)
    P = diag([3,8,6])*(rand(3,N)-.5);

    qn = cell(Nc,1);
    for j = 1:Nc
        p = [Rc{j} tc(:,j)]*[P;ones(1,N)];
        q = K*p./p(3,:);
        q = q(1:2,:);
        qn{j} = q+randn(2,N)*sn;
        plt_c(j).XData = qn{j}(1,:);
        plt_c(j).YData = qn{j}(2,:);
    end
        
    plt_P.XData = P(1,:);
    plt_P.YData = P(2,:);
    plt_P.ZData = P(3,:);
    
    pts = cell(Nc,1);
    try
        for j = 1:Nc
            pts{j} = SURFPoints(qn{j}');
        end
    catch
        continue
    end
    
    m = size(idx,1);
    E = cell(m,1);
    in_idx = cell(m,1);
    for j = 1:m
        [E{j},in_idx{j}] = estimateEssentialMatrix(pts{idx(j,1)+1},pts{idx(j,2)+1},cameraParams,'MaxDistance',sn);%,'Confidence', 99.99
    end

    indxFlag = 0;
    for j = 1:m
        if sum(in_idx{j})<.5*N
            indxFlag = 1;
        end
    end
    if indxFlag
        disp('indxFlag')
        continue
    end
    k = k + 1;
    
    tcr = zeros(3,m);
    z = cell(1,m);
    for j = 1:m
        [relativeOrientation,relativeLocation] = relativeCameraPose(E{j},cameraParams,pts{idx(j,2)+1},pts{idx(j,1)+1});
        z{j} = relativeOrientation;
        tcr(:,j) = relativeLocation;
    end

    Rh = RS_RLS_WOP(idx,z,100,1e-6);
    Rhc{1} = eye(3);
    Rhc(2:Nc) = Rh;
    for j = 1:Nc
        Rhc{j} = Rhc{j}*Rc{1};
    end
    
    t = zeros(3,m);
    for j = 1:m
        t(:,j) = Rhc{idx(j,1)+1}\tcr(:,j);
    end
    
    save TVG t idx
    options = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
        'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',false,'MaxIterations',1000,'FunctionTolerance',1e-12,'StepTolerance',1e-12);
    X0 = reshape(Pc-Pc(:,1),1,[]);
    indx = f1vgidx(X0).^2 > 1;
    if sum(indx) > 0
        display([indx' idx+1]);
    end
    t(:,indx) = -t(:,indx);
    save TVG t idx
    tic
    [x,resnorm1,residual1,exitflag1,output1] = lsqnonlin(@f1vgidx,X0,[],[],options);
    toc
    sprintf('f(x0)=%g -> f(x*)=%g',sum(f1vgidx(X0).^2),sum(f1vgidx(x).^2))
    Ps = reshape(x,3,[]);
    [s,R,m] = sR_m(Pc,Ps);
    Ps = s*R*Ps-m;
    for j = 1:Nc
        Rhc{j} = Rhc{j}*R';
    end
    plot3(Ps(1,:),Ps(2,:),Ps(3,:),'m.','Markersize',5,'linewidth',1);
    Pr1 = zeros(3,N);
    Pr2 = zeros(3,N);
    Pr3 = zeros(3,N);
    Pr4 = zeros(3,N);
    Pr5 = zeros(3,N);
    Pr6 = zeros(3,N);
    Pr7 = zeros(3,N);
    
    options = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
        'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',true,'MaxIterations',1000,'FunctionTolerance',1e-10,'StepTolerance',1e-10);
    options_wog = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
        'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',false,'MaxIterations',1000,'FunctionTolerance',1e-10,'StepTolerance',1e-10);
    for j = 1:N
        X = zeros(3,Nc);
        for l = 1:Nc
            X(:,l) = Rhc{l}\(K\[qn{l}(:,j);1]);
        end
        p = BestPoint(Ps,X);
        Pr1(:,j) = p;
        p = BestPointWeighted(Ps,X);
        Pr2(:,j) = p;
        
        P0 = Pr1(:,j)+0*randn(3,1);
        qns = zeros(2,Nc);
        for l = 1:Nc
            qns(:,l) = qn{l}(:,j);
        end
        if Nc == 2
            p = Hartly(Ps,Rhc,qns,K);
        else
            p = lsqnonlin(@(P) triCost(P,Ps,Rhc,qns,K),P0,[],[],options);
        end
        Pr3(:,j) = p;
        p = lsqnonlin(@(P) triCostL1(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
        Pr4(:,j) = p;
        p = lsqnonlin(@(P) triCostAngL2(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
        Pr5(:,j) = p;
        p = lsqnonlin(@(P) triCostAngL1(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
        Pr6(:,j) = p;
        p = Q_sweep(Ps,Rhc,qns,K,Pr1(:,j)+randn(3,1)/10);
        Pr7(:,j) = p;
    end
    [s,R,m] = sR_m(P,Pr1);
    Pr1 = s*R*Pr1-m;
    [s,R,m] = sR_m(P,Pr2);
    Pr2 = s*R*Pr2-m;
    [s,R,m] = sR_m(P,Pr3);
    Pr3 = s*R*Pr3-m;
    [s,R,m] = sR_m(P,Pr4);
    Pr4 = s*R*Pr4-m;
    [s,R,m] = sR_m(P,Pr5);
    Pr5 = s*R*Pr5-m;
    [s,R,m] = sR_m(P,Pr6);
    Pr6 = s*R*Pr6-m;
    [s,R,m] = sR_m(P,Pr7);
    Pr7 = s*R*Pr7-m;
    plot3(Pr1(1,:),Pr1(2,:),Pr1(3,:),'r.','Markersize',8)
    plot3(Pr2(1,:),Pr2(2,:),Pr2(3,:),'k.','Markersize',8)
    mep1(k,:) = sqrt(sum((Ps-Pc).^2));
    me_Mid(k) = mean(sqrt(sum((Pr1 - P).^2)));
    me_WMid(k) = mean(sqrt(sum((Pr2 - P).^2)));
    me_L2(k) = mean(sqrt(sum((Pr3 - P).^2)));
    me_L1(k) = mean(sqrt(sum((Pr4 - P).^2)));
    me_AngL2(k) = mean(sqrt(sum((Pr5 - P).^2)));
    me_AngL1(k) = mean(sqrt(sum((Pr6 - P).^2)));
    me_QSweep(k) = mean(sqrt(sum((Pr7 - P).^2)));
    se1(k) = std(sqrt(sum((Pr1 - P).^2)));
    se2(k) = std(sqrt(sum((Pr2 - P).^2)));
    se3(k) = std(sqrt(sum((Pr3 - P).^2)));
    se4(k) = std(sqrt(sum((Pr4 - P).^2)));
    se5(k) = std(sqrt(sum((Pr5 - P).^2)));
    se6(k) = std(sqrt(sum((Pr6 - P).^2)));
    se7(k) = std(sqrt(sum((Pr7 - P).^2)));
    if me_QSweep(k)>10*me_Mid(k)
        me_QSweep(k) = 0;
        k = k -1;
    end
    toc
    drawnow
end
display(k)
disp([mean(me_Mid) mean(me_WMid) mean(me_L2) mean(me_L1) mean(me_AngL2) mean(me_AngL1)  mean(me_QSweep)])
%%
figure
qw = 1:length(me_Mid);
b = bar([me_Mid(qw);me_WMid(qw);me_L2(qw);me_L1(qw);me_AngL2(qw);me_AngL1(qw);me_QSweep(qw)]'/1);
l = length(me_Mid);
legend({'MP','IRMP','L2','L1','AngL2','AngL1','Q-Sweep'})
hold on
grid on
%%
errorbar((1:l)-b(7).XOffset,me_Mid/1,se1/1,'.')
errorbar((1:l)-b(6).XOffset,me_WMid/1,se2/1,'.')
errorbar((1:l)-b(5).XOffset,me_L2/1,se3/1,'.')
errorbar((1:l)-b(4).XOffset,me_L1/1,se4/1,'.')
errorbar((1:l)-b(3).XOffset,me_AngL2/1,se5/1,'.')
errorbar((1:l)-b(2).XOffset,me_AngL1/1,se6/1,'.')
errorbar((1:l)-b(1).XOffset,me_QSweep/1,se7/1,'.')
% legend('Mid','WMid','L2','L1','AngL2','AngL1')
legend({'MP','IRMP','L2','L1','AngL2','AngL1','Q-Sweep'})
grid on
%%
figure
idxn0 = me_Mid > 0;
m1 = sum(me_Mid/1,2)./sum(me_Mid>0,2);
m2 = sum(me_WMid/1,2)./sum(me_WMid>0,2);
m3 = sum(me_L2/1,2)./sum(me_L2>0,2);
m4 = sum(me_L1/1,2)./sum(me_L1>0,2);
m5 = sum(me_AngL2/1,2)./sum(me_AngL2>0,2);
m6 = sum(me_AngL1/1,2)./sum(me_AngL1>0,2);
m7 = sum(me_QSweep/1,2)./sum(me_QSweep>0,2);
std1 = sqrt(sum((me_Mid/1-m1/1).^2,2)./(sum(idxn0,2)-1));
std2 = sqrt(sum((me_WMid/1-m2/1).^2,2)./(sum(idxn0,2)-1));
std3 = sqrt(sum((me_L2/1-m3/1).^2,2)./(sum(idxn0,2)-1));
std4 = sqrt(sum((me_L1/1-m4/1).^2,2)./(sum(idxn0,2)-1));
std5 = sqrt(sum((me_AngL2/1-m5/1).^2,2)./(sum(idxn0,2)-1));
std6 = sqrt(sum((me_AngL1/1-m6/1).^2,2)./(sum(idxn0,2)-1));
std7 = sqrt(sum((me_QSweep/1-m7/1).^2,2)./(sum(idxn0,2)-1));
% m = [mean(me_Mid,2) mean(me_WMid,2) mean(me_L2,2) mean(me_L1,2) mean(me_AngL2,2) mean(me_AngL1,2)];
m = [m1 m2 m3 m4 m5 m6 m7];
% stdm = [std(me_Mid,[],2) std(me_WMid,[],2) std(me_L2,[],2) std(me_L1,[],2) std(me_AngL2,[],2) std(me_AngL1,[],2)];
stdm = [std1 std2 std3 std4 std5 std6 std7];
md = [median(me_Mid) median(me_WMid) median(me_L2) median(me_L1) median(me_AngL2) median(me_AngL1) median(me_QSweep)]/1;
% errorbar(m,[std(me_Mid) std(me_WMid) std(me_L2) std(me_L1) std(me_AngL2) std(me_AngL1)],...
%     ':o','MarkerSize',10,'CapSize',30,'linewidth',2);
errorbar(m/15,stdm/15,...
    ':o','MarkerSize',10,'CapSize',30,'linewidth',2);
    %'MarkerEdgeColor','red','MarkerFaceColor','red')
hold on
errorbar(1:7,md/15,md/15-[min(me_Mid) min(me_WMid) min(me_L2) min(me_L1) min(me_AngL2) min(me_AngL1) min(me_QSweep)]/15,[max(me_Mid) max(me_WMid) max(me_L2) max(me_L1) max(me_AngL2) max(me_AngL1) max(me_QSweep)]/15-md/15,...
    '--s','MarkerSize',8,'CapSize',40)
% plot(ones(1,length(me_VGST3D))*1,me_VGST3D,'m.')
% plot(ones(1,length(me_VGOT3D))*2,me_VGOT3D,'m.')
% plot(ones(1,length(me_VGST2D))*3,me_VGST2D,'m.')
% plot(ones(1,length(me_VGOT2D))*4,me_VGOT2D,'m.')
grid on
xticks(1:7)
% xticklabels({'Mid','WMid','L2','L1','AngL2','AngL1'})
xticklabels({'MP','IRMP','L2','L1','AngL2','AngL1','Q-Sweep'})
xlim([0 8])
ylim([0 max([me_Mid me_WMid me_L2 me_L1 me_AngL2 me_AngL1 me_QSweep])*1.1/15])
%%
% load data
% k = length(Pc_h);
% Pc_h{k+1} = Pc;
% me_VGST3D_h{k+1} = mean(me_VGST3D);
% se_VGST3D_h{k+1} = std(me_VGST3D);
% me_VGOT3D_h{k+1} = mean(me_VGOT3D);
% se_VGOT3D_h{k+1} = std(me_VGOT3D);
% me_VGST2D_h{k+1} = mean(me_VGST2D);
% se_VGST2D_h{k+1} = std(me_VGST2D);
% me_VGOT2D_h{k+1} = mean(me_VGOT2D);
% se_VGOT2D_h{k+1} = std(me_VGOT2D);
% save data Pc_h...
%     me_VGST3D_h se_VGST3D_h me_VGOT3D_h se_VGOT3D_h...
%     me_VGST2D_h se_VGST2D_h me_VGOT2D_h se_VGOT2D_h