%% Experiments
% 4.3) Full Reconstruction Procedure in a Real Dataset

clear
load FountainP11Data

N = 20;
Nc = 3;
Nitr = 10;

PcAll = Pc;
RcAll = Rc;
f = figure('Position',[200,150,900,600]);
mep1 = zeros(1,Nc);
tc = zeros(3,Nc);

combs = combnk(2:10,Nc)';
itr = 0;
me_Mid = zeros(1);
me_WMid = zeros(1);
me_L2 = zeros(1);
me_L1 = zeros(1);
me_AngL2 = zeros(1);
me_AngL1 = zeros(1);
me_QSweep = zeros(1);
se1 = zeros(1);
se2 = zeros(1);
se3 = zeros(1);
se4 = zeros(1);
se5 = zeros(1);
se6 = zeros(1);
se7 = zeros(1);
for camidx = combs
    itr = itr + 1;
    disp('=================================')
    disp(itr)
    close(f);
    Pc = PcAll;
    Rc = RcAll;
    f = figure('Position',[600,150,900,600]);
    idxga = ((sum(inliers(:,camidx),2)==Nc)' & idxg);
    Nt = sum(idxga);
    display(Nt)
    N = min(20,Nt);
    E_estimation_method = 1;
    a = zeros(1,5000);
    a(idxg) = 1:sum(idxg);
    a = a(idxga);
    rp = randperm(Nt,N);
    P = Pg2d(:,a(rp));
    idxq = find(idxga);
    idxq = idxq(rp);
    
    ax = axes;
    C = linspace(0,1,N);
    plt_P = patch(P(1,:),P(2,:),P(3,:),C,'FaceColor','none','EdgeColor','flat','Marker','.','MarkerFaceColor','flat','Markersize',18);
    view([-40,20])
    colormap hsv
    axis equal vis3d
    hold on
    grid on
    ax.Position = [.0 .15 .7 .7];
    
    Pc = [Pc{camidx}];
    Rc = Rc(camidx);
    for i = 1:Nc
        plotCamera('Location',Pc(:,i),'Orientation',Rc{i},'Size',.2,'Label',['c' num2str(camidx(i))]);
        tc(:,i) = -Rc{i}*Pc(:,i);
    end
    set(gcf,'Renderer','opengl');
    view([-110,50])
    
    plt_c = patch([],[],[]);
    for i = 1:Nc
        axi = axes;
        axi.Position = [.72 .04+(i-1)*.98/Nc .25 .7/Nc];
        axi.Box = 'On';
        image(Imag{camidx(i)});
        title(['Camera' num2str(i)])
        hold on
        axis off equal
        p_i = [Rc{i} tc(:,i)]*[P;ones(1,N)];
        qi = K*p_i./p_i(3,:);
        qi = qi(1:2,:);
        plt_c(i) = patch(qi(1,:),qi(2,:),C,'FaceColor','none','EdgeColor','flat','Marker','.','MarkerFaceColor','flat','Markersize',15);
        set(gca,'Ydir','reverse')
        grid on
        axis equal
        xlim(axi,[0,3072])
        ylim(axi,[0,2048])
    end
    drawnow  
    
    cameraParams = cameraParameters('IntrinsicMatrix',K');
    
    %% =========================================
    sn = 1;
    k = 0;
    htc = zeros(500,3);
    hid = zeros(500,1);
    f.CurrentAxes = ax;
    for i = 1:Nitr
        indxFlag = 0;
        for ii=1:5
            disp(i)
            rp = randperm(Nt,N);
            P = Pg2d(:,a(rp));
            idxq = find(idxga);
            idxq = idxq(rp);
            qn = cell(Nc,1);
            for j = 1:Nc
                p = [Rc{j} tc(:,j)]*[P;ones(1,N)];
                q = K*p./p(3,:);
                q = q(1:2,:);
                qn{j} = [Ipts{camidx(j)}(cor(camidx(j),idxq)).x;Ipts{camidx(j)}(cor(camidx(j),idxq)).y];
                plt_c(j).XData = qn{j}(1,:);
                plt_c(j).YData = qn{j}(2,:);
            end

            plt_P.XData = P(1,:);
            plt_P.YData = P(2,:);
            plt_P.ZData = P(3,:);

            pts = cell(Nc,1);
            for j = 1:Nc
                pts{j} = SURFPoints(qn{j}');
            end

            idx = combnk(1:Nc,2)-1;
            m = size(idx,1);
            E = cell(m,1);
            in_idx = cell(m,1);
            try
                for j = 1:m
                    [E{j},in_idx{j}] = estimateEssentialMatrix(pts{idx(j,1)+1},pts{idx(j,2)+1},cameraParams,'MaxDistance',.5);%,'Confidence', 99.99
                end
                for j = 1:m
                    if sum(in_idx{j})<.5*N
                        indxFlag = 1;
                    end
                end
                break;
            catch
                indxFlag = 0;
            end

        end
        
        k = k + 1;

        tcr = zeros(3,m);
        z = cell(1,m);
        for j = 1:m
            [relativeOrientation,relativeLocation] = relativeCameraPose(E{j},cameraParams,pts{idx(j,2)+1},pts{idx(j,1)+1});
            z{j} = relativeOrientation;%*angle2dcm(randn*.02,randn*.02,randn*.02);
            tcr(:,j) = relativeLocation;
        end

        Rh = RS_RLS_WOP(idx,z,100,1e-6);
        Rhc{1} = eye(3);
        Rhc(2:Nc) = Rh;
        for j = 1:Nc
            Rhc{j} = Rhc{j}*Rc{1};
        end

        t = zeros(3,m);
        for j = 1:m
            t(:,j) = Rhc{idx(j,1)+1}\tcr(:,j);
        end

        save TVG t idx
        options = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
                'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',false,'MaxIterations',1000,'FunctionTolerance',1e-10,'StepTolerance',1e-10);
        X0 = reshape(Pc-Pc(:,1),1,[]);
        indx = f1vgidx(X0).^2 > 1;
        if sum(indx) > 0
            display([indx' idx+1]);
        end
        t(:,indx) = -t(:,indx);
        save TVG t idx
        tic
        [x,resnorm1,residual1,exitflag1,output1] = lsqnonlin(@f1vgidx,X0,[],[],options);
        toc
        Ps = reshape(x,3,[]);
        [s,R,m] = sR_m(Pc,Ps);
        Ps = s*R*Ps-m;
        for j = 1:Nc
            Rhc{j} = Rhc{j}*R';
        end
        plot3(Ps(1,:),Ps(2,:),Ps(3,:),'m.','Markersize',5,'linewidth',1);
        Pr1 = zeros(3,N);
        Pr2 = zeros(3,N);
        Pr3 = zeros(3,N);
        Pr4 = zeros(3,N);
        Pr5 = zeros(3,N);
        Pr6 = zeros(3,N);
        Pr7 = zeros(3,N);
        options = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
            'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',true,'MaxIterations',1000,'FunctionTolerance',1e-10,'StepTolerance',1e-10);
        options_wog = optimoptions('lsqnonlin','Display','off','Algorithm','levenberg-marquardt',...
            'MaxFunctionEvaluations',5000,'SpecifyObjectiveGradient',false,'MaxIterations',1000,'FunctionTolerance',1e-10,'StepTolerance',1e-10);
        for j = 1:N
            X = zeros(3,Nc);
            for l = 1:Nc
                X(:,l) = Rhc{l}\(K\[qn{l}(:,j);1]);
            end
            p = BestPoint(Ps,X);
            Pr1(:,j) = p;
            p = BestPointWeighted(Ps,X);
            Pr2(:,j) = p;

            P0 = Pr1(:,j)+0*randn(3,1);
            qns = zeros(2,Nc);
            for l = 1:Nc
                qns(:,l) = qn{l}(:,j);
            end
            if Nc == 2
                p = Hartly(Ps,Rhc,qns,K);
            else
                p = lsqnonlin(@(P) triCost(P,Ps,Rhc,qns,K),P0,[],[],options);
            end
            Pr3(:,j) = p;
            p = lsqnonlin(@(P) triCostL1(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
            Pr4(:,j) = p;
            p = lsqnonlin(@(P) triCostAngL2(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
            Pr5(:,j) = p;
            p = lsqnonlin(@(P) triCostAngL1(P,Ps,Rhc,qns,K),P0,[],[],options_wog);
            Pr6(:,j) = p;
            p = Q_sweep(Ps,Rhc,qns,K,Pr1(:,j));
            Pr7(:,j) = p;
        end
        [s,R,m] = sR_m(P,Pr1);
        Pr1 = s*R*Pr1-m;
        [s,R,m] = sR_m(P,Pr2);
        Pr2 = s*R*Pr2-m;
        [s,R,m] = sR_m(P,Pr3);
        Pr3 = s*R*Pr3-m;
        [s,R,m] = sR_m(P,Pr4);
        Pr4 = s*R*Pr4-m;
        [s,R,m] = sR_m(P,Pr5);
        Pr5 = s*R*Pr5-m;
        [s,R,m] = sR_m(P,Pr6);
        Pr6 = s*R*Pr6-m;
        [s,R,m] = sR_m(P,Pr7);
        Pr7 = s*R*Pr7-m;

        plot3(Pr1(1,:),Pr1(2,:),Pr1(3,:),'r.','Markersize',8)
        plot3(Pr2(1,:),Pr2(2,:),Pr2(3,:),'k.','Markersize',8)
        mep1(k,:) = sqrt(sum((Ps-Pc).^2));
        me_Mid(itr,k) = mean(sqrt(sum((Pr1 - P).^2)));
        me_WMid(itr,k) = mean(sqrt(sum((Pr2 - P).^2)));
        me_L2(itr,k) = mean(sqrt(sum((Pr3 - P).^2)));
        me_L1(itr,k) = mean(sqrt(sum((Pr4 - P).^2)));
        me_AngL2(itr,k) = mean(sqrt(sum((Pr5 - P).^2)));
        me_AngL1(itr,k) = mean(sqrt(sum((Pr6 - P).^2)));
        me_QSweep(itr,k) = mean(sqrt(sum((Pr7 - P).^2)));
        se1(itr,k) = std(sqrt(sum((Pr1 - P).^2)));
        se2(itr,k) = std(sqrt(sum((Pr2 - P).^2)));
        se3(itr,k) = std(sqrt(sum((Pr3 - P).^2)));
        se4(itr,k) = std(sqrt(sum((Pr4 - P).^2)));
        se5(itr,k) = std(sqrt(sum((Pr5 - P).^2)));
        se6(itr,k) = std(sqrt(sum((Pr6 - P).^2)));
        se7(itr,k) = std(sqrt(sum((Pr7 - P).^2)));
        
        toc
        drawnow
    end
    display(k)
    disp(mean(mep1))
end
%%
figure
idxn0 = me_Mid > 0;
m1 = sum(me_Mid,2)./sum(me_Mid>0,2);
m2 = sum(me_WMid,2)./sum(me_WMid>0,2);
m3 = sum(me_L2,2)./sum(me_L2>0,2);
m4 = sum(me_L1,2)./sum(me_L1>0,2);
m5 = sum(me_AngL2,2)./sum(me_AngL2>0,2);
m6 = sum(me_AngL1,2)./sum(me_AngL1>0,2);
m7 = sum(me_QSweep,2)./sum(me_QSweep>0,2);
std1 = sqrt(sum((me_Mid-m1).^2,2)./(sum(idxn0,2)-1));
std2 = sqrt(sum((me_WMid-m2).^2,2)./(sum(idxn0,2)-1));
std3 = sqrt(sum((me_L2-m3).^2,2)./(sum(idxn0,2)-1));
std4 = sqrt(sum((me_L1-m4).^2,2)./(sum(idxn0,2)-1));
std5 = sqrt(sum((me_AngL2-m5).^2,2)./(sum(idxn0,2)-1));
std6 = sqrt(sum((me_AngL1-m6).^2,2)./(sum(idxn0,2)-1));
std7 = sqrt(sum((me_QSweep-m7).^2,2)./(sum(idxn0,2)-1));
m = [m1 m2 m3 m4 m5 m6 m7];
stdm = [std1 std2 std3 std4 std5 std6 std7];
md = [median(me_Mid,2) median(me_WMid,2) median(me_L2,2) median(me_L1,2) median(me_AngL2,2) median(me_AngL1,2) median(me_QSweep,2)];

b = bar(m);
l = size(m,1);
hold on
errorbar((1:l)-b(7).XOffset,m(:,1),stdm(:,1),'.')
errorbar((1:l)-b(6).XOffset,m(:,2),stdm(:,2),'.')
errorbar((1:l)-b(5).XOffset,m(:,3),stdm(:,3),'.')
errorbar((1:l)-b(4).XOffset,m(:,4),stdm(:,4),'.')
errorbar((1:l)-b(3).XOffset,m(:,5),stdm(:,5),'.')
errorbar((1:l)-b(2).XOffset,m(:,6),stdm(:,6),'.')
errorbar((1:l)-b(1).XOffset,m(:,7),stdm(:,7),'.')
legend({'MP','IRMP','L2','L1','AngL2','AngL1','Q-Sweep'})
grid on
xticks(1:l);
set(gca,'TickLabelInterpreter', 'latex');
xlbl = cell(1,l);
for i = 1:l
    s1 = '\begin{tabular}{c}';
    s2 = '';
    for j = 1:Nc
        s2 = strcat(s2,[num2str(combs(j,i)) '\\']);
    end
    s3 = ' \end{tabular}';
    xlbl{i} = [s1 s2 s3];
end
xticklabels(xlbl)

%%
figure
errorbar(mean(m),std(m),...
    ':o','MarkerSize',10,'CapSize',30,'linewidth',2);
hold on
errorbar(1:7,median(m),median(m)-min(m),max(m)-median(m),...
    '--s','MarkerSize',8,'CapSize',40)
grid on
xticks(1:7)
xticklabels({'MP','IRMP','L2','L1','AngL2','AngL1','Q-Sweep'})
xlim([0 8])

