function pH = Hartly(Pc,Rc,qn,K)
    Skew = @(x) [0 -x(3) x(2);x(3) 0 -x(1);-x(2) x(1) 0];
    
    t12 = Rc{2}*(Pc(:,1)-Pc(:,2));
    t12 = t12/norm(t12);
    Er12 = Skew(t12)*Rc{2}*Rc{1}';
    Fr12 = K'\Er12/K;

    T1 = [1 0 -qn(1,1);0 1 -qn(2,1);0 0 1];
    T2 = [1 0 -qn(1,2);0 1 -qn(2,2);0 0 1];

    FH = T2'\(Fr12/T1);
%     e1 = null(FH);
%     e2 = null(FH');
%     if isempty(e1)
        [~,D,V] = svd(FH);
        [~,id] = min(diag(D));
        e1 = V(:,id);
%     end
%     if isempty(e2)
        [~,D,V] = svd(FH');
        [~,id] = min(diag(D));
        e2 = V(:,id);
%     end
    
    e1 = e1/(e1(1)^2+e1(2)^2);
    e2 = e2/(e2(1)^2+e2(2)^2);
    RH1 = [e1(1) e1(2) 0;-e1(2) e1(1) 0;0 0 1];
    RH2 = [e2(1) e2(2) 0;-e2(2) e2(1) 0;0 0 1];
    FH = RH2*FH*RH1';
    a = FH(2,2);
    b = FH(2,3);
    c = FH(3,2);
    d = FH(3,3);
    f1 = e1(3);
    f2 = e2(3);
    p6 = (- d*a^2*c*f1^4 + b*a*c^2*f1^4);
    p5 = (a^4 + 2*a^2*c^2*f2^2 - a^2*d^2*f1^4 + b^2*c^2*f1^4 + c^4*f2^4);
    p4 = (4*a^3*b - 2*a^2*c*d*f1^2 + 4*a^2*c*d*f2^2 + 2*a*b*c^2*f1^2 + 4*a*b*c^2*f2^2 - a*b*d^2*f1^4 + b^2*c*d*f1^4 + 4*c^3*d*f2^4);
    p3 = (6*a^2*b^2 - 2*a^2*d^2*f1^2 + 2*a^2*d^2*f2^2 + 8*a*b*c*d*f2^2 + 2*b^2*c^2*f1^2 + 2*b^2*c^2*f2^2 + 6*c^2*d^2*f2^4);
    p2 = (- a^2*c*d + 4*a*b^3 + a*b*c^2 - 2*a*b*d^2*f1^2 + 4*a*b*d^2*f2^2 + 2*b^2*c*d*f1^2 + 4*b^2*c*d*f2^2 + 4*c*d^3*f2^4);
    p1 = (- a^2*d^2 + b^4 + b^2*c^2 + 2*b^2*d^2*f2^2 + d^4*f2^4);
    p0 = (c*b^2*d - a*b*d^2);

    t = roots([p6 p5 p4 p3 p2 p1 p0]);
    t = t(t==real(t));
    s = t.^2./(1+f1^2*t.^2);
    s = s + (c*t+d).^2 ./ ((a*t+b).^2+f2^2*(c*t+d).^2);
    [s_min,idmin] = min(s);
    if s_min < 1/(f1^2)+c^2/(a^2+f2^2*c^2)
        t = t(idmin);
        l1 = [t*f1;1;-t];
        l2 = FH * [0;t;1];
    else
        fprintf('t->infty')
        l1 = [f1;0;-1];
        l2 = FH * [0;1;0];
    end
    x1 = [-l1(1)*l1(3);-l1(2)*l1(3);l1(1)^2+l1(2)^2];
    x2 = [-l2(1)*l2(3);-l2(2)*l2(3);l2(1)^2+l2(2)^2];
    x1 = T1\(RH1'*x1);
    x2 = T2\(RH2'*x2);
    x1 = x1/x1(3);
    x2 = x2/x2(3);
    X = zeros(3,2);
    X(:,1) = Rc{1}\(K\x1);
    X(:,2) = Rc{2}\(K\x2);
    pH = BestPoint(Pc,X);
end