% Triangulation Cost
function [F] = triCostAngL1(P,Pc,Rc,q,K)
% Nc -> Number of cameras
% q  -> Projection of 3d point P on cameras : 2xNc
% Pc -> Cameras' positions : 3xNc
% Rc -> Cell of rotation matrices of cameras : 1xNc
% F  -> sqrt(sqrt((qh-q)'*(qh-q))) : Ncx1
% g  -> dF/dP : Ncx3

f = K(1,1);
% u0 = K(1,3);
% v0 = K(2,3);
Nc = size(Pc,2);
qh = zeros(2,Nc);
F = zeros(1,Nc);
% g = zeros(3,Nc);
for i = 1:Nc
    X = [Rc{i} -Rc{i}*Pc(:,i)]*[P;1];
    Q = K*X;
    qh(:,i) = Q(1:2)/Q(3);
    theta = asin(norm(cross([qh(:,i);f],[q(:,i);f]))/norm(q(:,i))/norm(qh(:,i)));
    F(i) = sqrt(abs(theta));
%     g(:,i) = 1/F(i)*(qh(:,i)-q(:,i))'*f*[1/X(3) 0;0 1/X(3);-X(1)/X(3)^2 -X(2)/X(3)^2]'*Rc{i};
end
% g = g';
